#include "stdafx.h"
#include "drawcore.h"


DrawCore::DrawCore()
{
	state      = S_INSERT_NODE;
	start_node = -1;
	captured   = false;
}


void DrawCore::drag_arc( CDC * dc )
{
	int    old_mode = dc->SetROP2(R2_XORPEN);
	CPen * old_pen  = (CPen *)dc->SelectStockObject( WHITE_PEN );
	
	dc->MoveTo( start_drag );
	dc->LineTo( end_drag );

 	dc->SelectObject( old_pen );
	dc->SetROP2(old_mode);
}

void DrawCore::OnLButtonDown(UINT nFlags, CPoint point)
{
}

void DrawCore::OnMouseMove(UINT nFlags, CPoint point)
{
}

void DrawCore::OnLButtonUp(UINT nFlags, CPoint point)
{
}


void DrawCore::OnDraw(CDC* pDC, 
		svector<Node> & nodes,
		svector<Arco> & arcs )
{
	const int NODE_R = 4;

	//CGrapheditDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);

	arc_iterator a;

	CPen apen(PS_SOLID,3,RGB(0,0,128));

	CPen * old_pen = (CPen *)(pDC->SelectObject(&apen));

	for(a=arcs.begin();a!=arcs.end();++a)
	{
		pDC->MoveTo( nodes[a->n[0]].p );
		pDC->LineTo( nodes[a->n[1]].p );
	}

	CPen npen(PS_SOLID,2,RGB(128,0,0));

	CBrush nbrush( RGB(255,255,0) );

	pDC->SelectObject(&npen);

	CBrush * old_brush = (CBrush *)(pDC->SelectObject(&nbrush));

	node_iterator n;

	for(n=nodes.begin();n!=nodes.end();++n)
	{
		pDC->Ellipse(
			n->p.x-NODE_R,
			n->p.y-NODE_R,
			n->p.x+NODE_R,
			n->p.y+NODE_R
		);
	}

	pDC->SelectObject(old_pen);
	pDC->SelectObject(old_brush);
}
