#ifndef __SHQN__GRAFOCORE__
#define __SHQN__GRAFOCORE__

//#include <vector>

template<class T> class svector
{
public:
	typedef T * iterator;

	inline svector() 
	{
		buf =0;
		siz =0;
		mem =0; 
	}
	inline svector( const int n )
	{
		siz = mem = n;
		buf  = new T[n];
	}
	inline ~svector()
	{
		if(buf) delete[] buf;
	}
	inline T & operator[]( const int i )
	{
		return buf[i];
	}
	inline const T & operator[]( const int i ) const
	{
		return buf[i];
	}
	inline int size() const { return siz; }
	inline void alloc( int n )
	{
		if(n>=mem)
		{
			if(mem==0)
			{
				mem = n;
				buf = new T[n];
			}
			else
			{
				T * t = new T[n];
				for(int i=0;i<mem;++i)
					t[i]=buf[i];
				delete[] buf;
				buf = t;
				mem = n;
			}
		}
	}
	inline svector & resize( const int n )
	{
		if(n>=mem) alloc(n);
		siz = n;
		return *this;
	}

	inline svector & push_back( const T & a )
	{
		if(siz>=mem)
		{
			if(mem==0) alloc(256);
			else       alloc(mem*2);
		}
		buf[siz++]=a;
		return *this;
	}
	inline iterator begin() { return buf; }
	inline iterator end() { return buf+siz; }
private:
	T * buf;
	int siz;
	int mem;
};

class Node
{
public:
	CPoint p;

	inline Node() {}
	inline Node( const CPoint & np ) { p = np; }
	void Serialize(CArchive& ar);
};

class Arco
{
public:
	int n[2];

	inline Arco() {}
	inline Arco( const int n0, const int n1 ) { n[0]=n0; n[1]=n1; }
	inline bool operator== ( const Arco & a )
	{
		return n[0]==a.n[0] && n[1]==a.n[1];
	}
	void Serialize(CArchive& ar);
};


typedef svector<Node>::iterator node_iterator;
typedef svector<Arco>::iterator  arc_iterator;

#endif