// GraphactivexCtl.cpp : Implementation of the CGraphactivexCtrl ActiveX Control class.

#include "stdafx.h"
#include "graphactivex.h"
#include "GraphactivexCtl.h"
#include "GraphactivexPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CGraphactivexCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CGraphactivexCtrl, COleControl)
	//{{AFX_MSG_MAP(CGraphactivexCtrl)
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CGraphactivexCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CGraphactivexCtrl)
	// NOTE - ClassWizard will add and remove dispatch map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CGraphactivexCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CGraphactivexCtrl, COleControl)
	//{{AFX_EVENT_MAP(CGraphactivexCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CGraphactivexCtrl, 1)
	PROPPAGEID(CGraphactivexPropPage::guid)
END_PROPPAGEIDS(CGraphactivexCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CGraphactivexCtrl, "GRAPHACTIVEX.GraphactivexCtrl.1",
	0xb0b9f785, 0x3fac, 0x11d5, 0x9e, 0x25, 0, 0x80, 0xc8, 0x8b, 0x30, 0xaf)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CGraphactivexCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DGraphactivex =
		{ 0xb0b9f783, 0x3fac, 0x11d5, { 0x9e, 0x25, 0, 0x80, 0xc8, 0x8b, 0x30, 0xaf } };
const IID BASED_CODE IID_DGraphactivexEvents =
		{ 0xb0b9f784, 0x3fac, 0x11d5, { 0x9e, 0x25, 0, 0x80, 0xc8, 0x8b, 0x30, 0xaf } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwGraphactivexOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CGraphactivexCtrl, IDS_GRAPHACTIVEX, _dwGraphactivexOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::CGraphactivexCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CGraphactivexCtrl

BOOL CGraphactivexCtrl::CGraphactivexCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_GRAPHACTIVEX,
			IDB_GRAPHACTIVEX,
			afxRegApartmentThreading,
			_dwGraphactivexOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::CGraphactivexCtrl - Constructor

CGraphactivexCtrl::CGraphactivexCtrl()
{
	InitializeIIDs(&IID_DGraphactivex, &IID_DGraphactivexEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::~CGraphactivexCtrl - Destructor

CGraphactivexCtrl::~CGraphactivexCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::OnDraw - Drawing function

void CGraphactivexCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	
	//pdc->Ellipse(rcBounds);
	
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	dc.OnDraw(pdc,nodes,arcs);
}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::DoPropExchange - Persistence support

void CGraphactivexCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::OnResetState - Reset control to default state

void CGraphactivexCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl::AboutBox - Display an "About" box to the user

void CGraphactivexCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_GRAPHACTIVEX);
	dlgAbout.DoModal();
}



inline int Dist( const CPoint & a, const CPoint & b )
{
	int dx = a.x - b.x;
	int dy = a.y - b.y;
	return dx*dx+dy*dy;
}

int CGraphactivexCtrl::FindNode( const CPoint & p )
{
	const int TOLL = 25;

	int mind = -1;
	int minn = -1; 
	for(int n=0;n<nodes.size();++n)
	{
		int d = Dist( p, nodes[n].p );
		if( mind==-1 || mind>d )
		{
			mind = d;
			minn = n;
		}
	}
	if(mind<=TOLL) return minn;
	else return -1;
}

/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl message handlers

void CGraphactivexCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(dc.captured)
	{
		//CGrapheditDoc* pDoc = GetDocument();
		//ASSERT_VALID(pDoc);

		CDC * pdc = GetDC();
		dc.drag_arc(pdc);
		ReleaseDC(pdc);
		ReleaseCapture();
		dc.captured = false;
		dc.end_node = FindNode(point);
		if( dc.end_node!=-1 && dc.end_node!=dc.start_node)
		{
			add_arc(dc.start_node,dc.end_node);
		}
	}
	COleControl::OnLButtonUp(nFlags, point);
}

void CGraphactivexCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	switch(dc.state)
	{
	case DrawCore::S_INSERT_NODE:
		add_node(point);
		break;
	case DrawCore::S_INSERT_ARC:
		{
			dc.start_node = FindNode(point);
			if(dc.start_node!=-1)
			{
				dc.end_node = dc.start_node;
				dc.start_drag = dc.end_drag = nodes[dc.start_node].p;  
				CDC * pdc = GetDC();
				dc.drag_arc(pdc);
				ReleaseDC(pdc);
				SetCapture();
				dc.captured = true;
			}
		}
		break;
	}
		
	COleControl::OnLButtonDown(nFlags, point);
}

void CGraphactivexCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(dc.captured)
	{
		CDC * pdc = GetDC();
		dc.drag_arc(pdc);
		dc.end_drag = point;
		dc.drag_arc(pdc);
		ReleaseDC(pdc);
	}
	
	COleControl::OnMouseMove(nFlags, point);
}

void CGraphactivexCtrl::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if(dc.state == DrawCore::S_INSERT_NODE)
		dc.state = DrawCore::S_INSERT_ARC;
	else
		dc.state = DrawCore::S_INSERT_NODE;	

	COleControl::OnRButtonUp(nFlags, point);
}
