#if !defined(AFX_GRAPHACTIVEXCTL_H__B0B9F793_3FAC_11D5_9E25_0080C88B30AF__INCLUDED_)
#define AFX_GRAPHACTIVEXCTL_H__B0B9F793_3FAC_11D5_9E25_0080C88B30AF__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "..\\grafocore.h"
#include "..\\drawcore.h"

// GraphactivexCtl.h : Declaration of the CGraphactivexCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CGraphactivexCtrl : See GraphactivexCtl.cpp for implementation.

class CGraphactivexCtrl : public COleControl
{
	DECLARE_DYNCREATE(CGraphactivexCtrl)

// Constructor
public:
	CGraphactivexCtrl();

	
	DrawCore dc;
	svector<Node> nodes;
	svector<Arco>  arcs;

	inline void add_node( const CPoint & p )
	{
		nodes.push_back( Node(p) );
		//UpdateAllViews(0);
		InvalidateControl();
	}

	inline void add_arc( const int n0, const int n1 )
	{
		arcs.push_back( Arco(n0,n1) );
		//UpdateAllViews(0);
		InvalidateControl();
	}

	int FindNode( const CPoint & p );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphactivexCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CGraphactivexCtrl();

	DECLARE_OLECREATE_EX(CGraphactivexCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CGraphactivexCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CGraphactivexCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CGraphactivexCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CGraphactivexCtrl)
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CGraphactivexCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CGraphactivexCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CGraphactivexCtrl)
		// NOTE: ClassWizard will add and remove enumeration elements here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAPHACTIVEXCTL_H__B0B9F793_3FAC_11D5_9E25_0080C88B30AF__INCLUDED)
