// grapheditDoc.h : interface of the CGrapheditDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPHEDITDOC_H__5369F2CC_F096_11D4_9E24_0080C88B30AF__INCLUDED_)
#define AFX_GRAPHEDITDOC_H__5369F2CC_F096_11D4_9E24_0080C88B30AF__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "grafocore.h"

class CGrapheditDoc : public CDocument
{
protected: // create from serialization only
	CGrapheditDoc();
	DECLARE_DYNCREATE(CGrapheditDoc)

// Attributes
public:
	svector<Node> nodes;
	svector<Arco>  arcs;

// Operations
public:

	inline void add_node( const CPoint & p )
	{
		nodes.push_back( Node(p) );
		UpdateAllViews(0);
	}

	inline void add_arc( const int n0, const int n1 )
	{
		arcs.push_back( Arco(n0,n1) );
		UpdateAllViews(0);
	}

	int FindNode( const CPoint & p );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrapheditDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGrapheditDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGrapheditDoc)
	afx_msg void OnOparchi();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAPHEDITDOC_H__5369F2CC_F096_11D4_9E24_0080C88B30AF__INCLUDED_)
